# -*- coding: utf-8 -*-
"""
Created on Thu Nov 26 11:46:42 2015

@author: benedikt
"""

import os
from matplotlib.pylab import *
import matplotlib.pylab
import matplotlib
from pylab import *
from numpy import *
matplotlib.use('Qt4Agg')

def g(x):
    return (x-2)**3-x**2+10
    
def IntegrateRiemann(N,a,b,f):
    xvalues=linspace(a,b,N+1)+(b-a)/(2.0*N)
    fx=f(xvalues)
    weightRiemann=ones(N+1)
    weightRiemann[N]=0
    weightRiemann=(b-a)/(N*1.0)*weightRiemann
    return dot(weightRiemann,fx) 
    
def IntegrateTrapez(N,a,b,f):
    xvalues=linspace(a,b,N+1)
    fx=f(xvalues)
    weight=ones(N+1)
    weight[0]=0.5
    weight[N]=0.5
    weight=(b-a)/(N*1.0)*weight
    return dot(weight,fx) 
    
def IntegrateSimpson(N,a,b,f):
    xvalues=linspace(a,b,N+1)
    fx=f(xvalues)
    weight=2*(linspace(1,N+1,N+1)%2)+4*(linspace(0,N,N+1)%2)    
    weight[0]=1
    weight[N]=1
    weight=(b-a)/(N*3.0)*weight
    return dot(weight,fx) 
    
a=0
b=4

Nvalues=linspace(4,100,97)
Intvalues=zeros(len(Nvalues))

intana=56.0/3.0

for i in range(len(Nvalues)):
    Intvalues[i]=abs(IntegrateRiemann(Nvalues[i],a,b,g)-intana)

#%%    
loglog(Nvalues,Intvalues,'.')


k=0
while k<len(Nvalues):
    if Intvalues[k]<0.01:
        print(Nvalues[k])
        k=len(Nvalues)+42
    k+=1


